//----------------------------------------------------------------------------
// HW_32.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: HW_32.pas
//----------------------------------------------------------------------------
#ifndef HW_32HPP
#define HW_32HPP
//----------------------------------------------------------------------------
#include <Windows.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <System.hpp>
namespace Hw_32
{
//-- type declarations -------------------------------------------------------
struct HW_32_1
{
	Word PortAddr;
	Byte PortData;
	bool fWrite;
} ;

typedef HW_32_1 PortRec[65535];

typedef PortRec *pPortRec;

class __declspec(delphiclass) TVicHw32;
class __declspec(pascalimplementation) TVicHw32 : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	bool fWin95;
	bool fTerminated;
	bool fMemoryMapped;
	int fInterface;
	int fBus;
	int fPhysLoPart;
	int fPhysHiPart;
	int fTypeMem;
	int fMemorySize;
	void *fMemoryPointer;
	int fLocEvent;
	long *fpCounter;
	bool fHardAccess;
	bool fIsIRQSet;
	bool fMasked;
	bool fOpenDrive;
	int hDRV;
	Classes::TNotifyEvent fOnHwInterrupt;
	int fIRQNumber;
	int fThreadId;
	int fThreadHandle;
	_RTL_CRITICAL_SECTION fHWCritSect_IO;
	_RTL_CRITICAL_SECTION fHWCritSect_IRQ;
	int fEventIRQSet;
	int __fastcall GetInterruptCounter(void);
	int __fastcall CtlCode(Word Code);
	void __fastcall SetActiveDriver(bool flag);
	Byte __fastcall ReadPort(Word nPort);
	void __fastcall WritePort(Word nPort, Byte pval);
	Word __fastcall ReadPortW(Word nPort);
	void __fastcall WritePortW(Word nPort, Word pval);
	int __fastcall ReadPortL(Word nPort);
	void __fastcall WritePortL(Word nPort, int pval);
	void __fastcall UnmapMemory(void);
	
protected:
	long fHandled;
	
public:
	__fastcall virtual TVicHw32(Classes::TComponent* Owner);
	__fastcall virtual ~TVicHw32(void);
	void __fastcall OpenDriver(void);
	void __fastcall CloseDriver(void);
	void __fastcall SetIRQ(void);
	void __fastcall DestroyIRQ(void);
	void __fastcall MaskInterrupt(void);
	void __fastcall UnmaskInterrupt(void);
	void * __fastcall MapPhysToLinear(int PhAddr, int Size);
	void __fastcall PortControl(pPortRec Ports, Word NumPorts);
	void __fastcall ReadPortFIFO(Word PortAddr, Word NumPorts, void *Buffer);
	void __fastcall WritePortFIFO(Word PortAddr, Word NumPorts, void *Buffer);
	__property Byte Port[Word Index] = {read=ReadPort, write=WritePort};
	__property Word PortW[Word Index] = {read=ReadPortW, write=WritePortW};
	__property int PortL[Word Index] = {read=ReadPortL, write=WritePortL};
	__property bool IsIRQSet = {read=fIsIRQSet, nodefault};
	__property bool Masked = {read=fMasked, nodefault};
	__property int IRQCounter = {read=GetInterruptCounter, nodefault};
	void __fastcall SimulateHwInt(void);
	
__published:
	__property bool ActiveHW = {read=fOpenDrive, write=SetActiveDriver, nodefault};
	__property Classes::TNotifyEvent OnHwInterrupt = {read=fOnHwInterrupt, write=fOnHwInterrupt};
	__property int IRQNumber = {read=fIRQNumber, write=fIRQNumber, nodefault};
	__property bool HardAccess = {read=fHardAccess, write=fHardAccess, default=0};
};

//-- var, const, procedure ---------------------------------------------------
#define _DRV_MAP_MEMORY (Byte)(2)
#define _DRV_UNMAP_MEMORY (Byte)(3)
#define _DRV_GET_INTERRUPT_COUNTER (Byte)(4)
#define _DRV_SET_POST_EVENT (Byte)(5)
#define _DRV_SET_INT_VEC (Byte)(6)
#define _DRV_MASK_INT_VEC (Byte)(7)
#define _DRV_UNMASK_INT_VEC (Byte)(8)
#define _DRV_STOP_INT_VEC (Byte)(9)
#define _DRV_PORT_CONTROL (Byte)(10)
#define _DRV_HARD_READ_PORT (Byte)(11)
#define _DRV_HARD_WRITE_PORT (Byte)(12)
#define _DRV_HARD_READ_PORTW (Byte)(13)
#define _DRV_HARD_WRITE_PORTW (Byte)(14)
#define _DRV_HARD_READ_PORTL (Byte)(15)
#define _DRV_HARD_WRITE_PORTL (Byte)(16)
#define _DRV_PULSE_EVENT (Byte)(17)
#define _DRV_READ_FIFO (Byte)(18)
#define _DRV_WRITE_FIFO (Byte)(19)
extern void __fastcall Register(void);
extern void __fastcall finalization(void);

}	/* namespace Hw_32 */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Hw_32;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// HW_32
